/*--------------------------------------------------------------*/
//STC89C51RC EEPROM
//EEPROM ݲ֮Ϊ0xff, ĬϳҲΪ0xff
//EEPROM λֻ(1)Ϊ(0)(0)Ϊ(1) !!!
//, дݵʱֻȽٽд
//Fosc = 12MHz
//Time:	21:40 2009-5-13


/*--------------------------------------------------------------*/
//ͷļ
#include "STC_EEPROM.H"


/*--------------------------------------------------------------*/
//Ĵ
sfr ISP_DATA	=	0xE2;
sfr ISP_ADDRH	=	0xE3;
sfr ISP_ADDRL	=	0xE4;
sfr ISP_CMD		=	0xE5;
sfr ISP_TRIG	=	0xE6;
sfr ISP_CONTR	=	0xE7;


/*--------------------------------------------------------------*/
//궨
#define ISP_CMD_READ	0x01		//EEPROMֽڶ		 
#define ISP_CMD_WRITE	0x02		//EEPROMֽд	
#define ISP_CMD_ERASE	0x03		//EEPROM 512ֽ

#define	ISP_EN_WAIT_TIME0	0x80	//Fosc > 20MHz
#define	ISP_EN_WAIT_TIME1	0x81	//Fosc < 20MHz
#define	ISP_EN_WAIT_TIME2	0x82	//Fosc < 10MHz
#define	ISP_EN_WAIT_TIME3	0x83	//Fosc <  5MHz

#define DATA_FLASH_START_ADDR_51	0x2000	//ÿ512(0x200)ֽ, 8, 4k	
#define DATA_FLASH_START_ADDR_52	0x2000	//ÿ512(0x200)ֽ, 8, 4k
#define DATA_FLASH_START_ADDR_54	0x8000	//ÿ512(0x200)ֽ, 58


/*--------------------------------------------------------------*/
//(˽)
void Trigger_ISP(void);		//ISP
void IAP_Disable(void);		//رIAP, ISPؼĴ


/*--------------------------------------------------------------*/
//ISP
void Trigger_ISP(void)
{
	EA = 0;
	ISP_TRIG = 0x46;
	ISP_TRIG = 0xb9;
	_nop_();
	EA = 1;
}


/*--------------------------------------------------------------*/
//رIAP, ISPؼĴ
void IAP_Disable(void)
{
	ISP_CONTR = 0x00;
	ISP_CMD	  = 0x00;
	ISP_TRIG  = 0x00;
}


/*--------------------------------------------------------------*/
//EEPROMֽڶ
unsigned char EEPROM_Read_Byte(unsigned int eeprom_addr)
{
	unsigned char dat;

	ISP_CONTR = ISP_EN_WAIT_TIME1;		//в, Fosc < 20MHz
	ISP_CMD   = ISP_CMD_READ;			//EEPROMֽڶ
	ISP_ADDRH = (unsigned char) (eeprom_addr >> 8);
	ISP_ADDRL = (unsigned char) (eeprom_addr & 0xff);
	EA = 0;
	ISP_TRIG  = 0x46;					//ISP
	ISP_TRIG  = 0xb9;					//ISP
	_nop_();
	dat = ISP_DATA;						//
	EA = 1;
	IAP_Disable();						//رIAP
	return (dat);
}


/*--------------------------------------------------------------*/
//EEPROMֽڶ
void EEPROM_Read_block(unsigned int eeprom_addr, unsigned char *p_dat, unsigned char num)
{
	unsigned char i;
	for(i = 0; i < num; i++)
	{
		*p_dat = EEPROM_Read_Byte(eeprom_addr);
		p_dat++;	
	}
}


/*--------------------------------------------------------------*/
//EEPROMֽд
void EEPROM_Write_Byte(unsigned int eeprom_addr, unsigned char dat)
{
	ISP_CONTR = ISP_EN_WAIT_TIME1;		//в, Fosc < 20MHz
	ISP_CMD   = ISP_CMD_WRITE;			//EEPROMֽд
	ISP_ADDRH = (unsigned char) (eeprom_addr >> 8);
	ISP_ADDRL = (unsigned char) (eeprom_addr & 0xff);
	ISP_DATA  = dat;					//д
	Trigger_ISP();						//ISP
	IAP_Disable();						//رIAP
}


/*--------------------------------------------------------------*/
//EEPROMֽд
void EEPROM_Write_block(unsigned int eeprom_addr, unsigned char *p_dat, unsigned int num)
{
	unsigned int i;
	for(i = 0; i < num; i++)
	{	
		EEPROM_Write_Byte(eeprom_addr + i, *p_dat);
		p_dat++;
	}
}


/*--------------------------------------------------------------*/
//EEPROM 512ֽ
void EEPROM_Sector_Erase(unsigned char num_block)
{
	unsigned int temp_addr;
	temp_addr = DATA_FLASH_START_ADDR_51 + (num_block * 0x200);
	ISP_CONTR = ISP_EN_WAIT_TIME1;		//в, Fosc < 20MHz
	ISP_CMD   = ISP_CMD_ERASE;			//EEPROM
	ISP_ADDRH = (unsigned char) (temp_addr >> 8);
	ISP_ADDRL = (unsigned char) (temp_addr & 0xff);
	Trigger_ISP();						//ISP
	IAP_Disable();						//رIAP
}
/*--------------------------------------------------------------*/